   '***********************************************************************'
   ' Tester plochch zezovch kabel - 14 vodi                         '
   '                                                                       '
   ' v 2.2.0 (z 20.6.2010)                                                 '
   '                                                                       '
   ' Autor : Pavel Jank                                                   '
   ' www.paja-trb.cz
   ' paja@paja-trb.cz
   '                                                                       '
   '***********************************************************************'
   'oproti verzi HW2 je zde zrcadlove prohozeno poradi konektoru MWL14 (pin1 az 14) !!!


'$sim                                                        '!!!Odstranit pi programovn - zrychlen simulace

$regfile = "m8def.dat"                                      'Soubor s deklaracemi
$crystal = 4000000                                          'Kmitoet osciltoru v Hz

Dim A As Byte
Dim Ok As Byte
Dim Piny1az8 As Byte
Dim Piny9az14 As Byte
Dim Vystupy1az8 As Byte
Dim Vystupy9az14 As Byte


'pojmenovani jednotlivych pinu port
Pin1 Alias Portd.7                                          'pojmenuje portd.7 jako Pin1
Pin2 Alias Portd.6
Pin3 Alias Portd.5
Pin4 Alias Portd.4
Pin5 Alias Portd.3
Pin6 Alias Portd.2
Pin7 Alias Portd.1
Pin8 Alias Portd.0

Pin9 Alias Portc.0
Pin10 Alias Portc.1
Pin11 Alias Portc.2
Pin12 Alias Portc.3
Pin13 Alias Portc.4
Pin14 Alias Portc.5

Tlac Alias Pinb.2
Alarm Alias Portb.0
Zeled Alias Portb.1
Piezo Alias Portb.7
Zapni Alias Portb.6


Config Timer1 = Timer , Prescale = 1024                     '1krok tae = 1 / 4 (MHz) * 1024 (peddli) = 250 mikrosec
On Ovf1 Cas_vyprsel                                         'obsluha peruen od Timeru0
Timer1 = 0                                                  'Poten hodnota registru TCNT1 (t od 0 do max. 65536 "16bit" -> 128mikrosec * 65536 = 16,384s)
Enable Timer1                                               'povol timer1
Enable Interrupts                                           'zaka vechna peruen


Config Portc = Input
Config Portd = Input
Portc = &B_1111_1111
Portd = &B_1111_1111

Config Tlac = Input                                         'resetovaci tlacitko
Tlac = 1                                                    'pull-up (tlacitko spina v log. 0 - oproti Gnd)
Config Zeled = Output                                       'zelena LED
Zeled = 1
Config Alarm = Output                                       'cervena LED
Alarm = 1
Config Piezo = Output
Piezo = 0
Config Zapni = Output                                       'vystup drzici si napajeni pro sebe - jinak se vypne
Zapni = 1                                                   'zapni si a drz napajeni

Piny1az8 = &B_1111_1111
Piny9az14 = &B_0011_1111                                    'PC6 a 7 neni pouzity, proto na jeho miste 0 !!!
Ok = 0
Start Timer1


 ''''''''''''''' HLAVNI PROGRAM '''''''''''''''''''''''''''''''''''''''''''''''

 Do

   Config Portc = &B_1100_0000
   Vystupy9az14 = &B_0011_1111

   Config Portd = &B_1000_0000                              'PortD.7 (Pin1) vstupn, ostatn vstupn (0 je vstup, 1 je vstup)
   Vystupy1az8 = &B_0111_1111                               'do pomocne uloz spravny (bezporuchovy) stav pro porovnani v podprogramu kontrola
   Pin1 = 0                                                 'Pin1 (vstupn) resetuj (led se rozsviti)
   Gosub Kontrola                                           'skoc do podprogramu kontrola

   Config Portd = &B_0100_0000
   Vystupy1az8 = &B_1011_1111
   Pin1 = 1
   Pin2 = 0
   Gosub Kontrola

   Config Portd = &B_0010_0000
   Vystupy1az8 = &B_1101_1111
   Pin2 = 1
   Pin3 = 0
   Gosub Kontrola

   Config Portd = &B_0001_0000
   Vystupy1az8 = &B_1110_1111
   Pin3 = 1
   Pin4 = 0
   Gosub Kontrola

   Config Portd = &B_0000_1000
   Vystupy1az8 = &B_1111_0111
   Pin4 = 1
   Pin5 = 0
   Gosub Kontrola

   Config Portd = &B_0000_0100
   Vystupy1az8 = &B_1111_1011
   Pin5 = 1
   Pin6 = 0
   Gosub Kontrola

   Config Portd = &B_0000_0010
   Vystupy1az8 = &B_1111_1101
   Pin6 = 1
   Pin7 = 0
   Gosub Kontrola

   Config Portd = &B_0000_0001
   Vystupy1az8 = &B_1111_1110
   Pin7 = 1
   Pin8 = 0
   Gosub Kontrola

'---------------------------------
   Config Portd = Input
   Vystupy1az8 = &B_1111_1111


   Config Portc = &B_1100_0001
   Vystupy9az14 = &B_0011_1110
   Pin8 = 1
   Pin9 = 0
   Gosub Kontrola

   Config Portc = &B_1100_0010
   Vystupy9az14 = &B_0011_1101
   Pin9 = 1
   Pin10 = 0
   Gosub Kontrola

   Config Portc = &B_1100_0100
   Vystupy9az14 = &B_0011_1011
   Pin10 = 1
   Pin11 = 0
   Gosub Kontrola

   Config Portc = &B_1100_1000
   Vystupy9az14 = &B_0011_0111
   Pin11 = 1
   Pin12 = 0
   Gosub Kontrola

   Config Portc = &B_1101_0000
   Vystupy9az14 = &B_0010_1111
   Pin12 = 1
   Pin13 = 0
   Gosub Kontrola

   Config Portc = &B_1110_0000
   Vystupy9az14 = &B_0001_1111
   Pin13 = 1
   Pin14 = 0
   Gosub Kontrola

   Pin14 = 1

   Incr Ok                                                  'inkrementuj obsah OK (piti 1)
   If Ok = 15 Then                                          'Kdyz probehl test 15x po sobe v poradku, tak ...
   Gosub Test_ok
   End If

Loop

 ''''''''''''''' KONEC HLAVNIHO PROGRAMU ''''''''''''''''''''''''''''''''''''''
 End


' podprogram kontrola, je-li nekde zkrat mezi piny skoci do chyba, rozsviti LED alarm a
' ceka na stisk tlac (aby obsluha videla na rozsvicenych LEDkach zkratovane pin)
' teprve po stisku TLAC bude pokracovat v kontrole dalsich pinu ...

Kontrola:
Tlac = 1

'prodleva nutn ke sprvn funkci - pokud se delsi vodic chova jako kondenzator o kapacite az 4nF a vic (testovano az 100n), tak je nutno pockat alespon 10ms !!! a pak teprve nacist piny
' (150m klubo plochho kabelu 14vodi - namen odpor vodie cca 20ohm a kapacita sousednch vodi cca 4nF)
Waitms 20

Piny1az8 = Pind                                             'znovu nacti stav na pinech
A = Piny1az8 - Vystupy1az8                                  'do pomocne A uloz rozdil nactene hodnoty z portu a prednastavene bezporuchove hodnoty
If A <> 0 Then                                              'kdyz neni rozdil roven nule tak vyhlas chybu ...
Goto Chyba
End If


Piny9az14 = Pinc
A = Piny9az14 - Vystupy9az14
If A = 0 Then                                               'kdyz je rozdil roven nule, tak preskoc na pokracuj
Goto Pokracuj
End If


Chyba:                                                      'zkratovane piny
Ok = 0                                                      'vynuluj pocitadlo OK
Timer1 = 0                                                  'vynuluj timer1 - odpoet do vypnut napjen (16s)
Reset Alarm                                                 'resetuj alarm (rozsviti cervenou LED)
Set Piezo                                                   'zapni piezo
Waitms 400
Reset Piezo

Bitwait Tlac , Reset                                        'ekej na stisk tlatka
Waitms 50                                                   'ochrana kvli zkmitm
Bitwait Tlac , Set                                          'ekej na uvolnn tlatka

Pokracuj:
Set Alarm                                                   'deaktivuj alarm

Return                                                      'navrat z podprogramu


'----------------------

'pokud probehlo testovani 15x po sobe v poradku tak
Test_ok:
Ok = 0
Reset Zeled                                                 'rozsvit zelenou LED
'parkrat si zapiskej
Set Piezo
Waitms 100
Reset Piezo
Waitms 80
Set Piezo
Waitms 150
Reset Piezo

Wait 1
Set Zeled                                                   'zhasni zelenou LED

Return

'----------------------

'po uplynuti casu dane casovacem1 (neco kolem 17s) zapipa piezo a pak se vypne napajeni
Cas_vyprsel:
Reset Alarm

Set Piezo
Waitms 150
Reset Piezo
Waitms 400

Set Piezo
Waitms 150
Reset Piezo
Waitms 250

Set Piezo
Waitms 400
Reset Piezo

Wait 1

Reset Zapni

Return


'------------------------------------------------------------------------------
' ! nastaveni FUSES v PonyProg !
' -  : (1) prazne        +  : (0) zatrzene (J)
'
' SELFPRGEN          -
' DWEN               -
' BODLEVEL1          -
' BODLEVEL0          -
' EESAVE             -
' WDTOM              - (1)
' CKDIV8             - (1)
' SUT1               - (1)
' SUT0             J + (0)
' CLKSEL3          J + (0)
' CLKSEL2          J + (0)
' CLKSEL1            - (1)
' CLKSEL0            - (1)
'
'           CLKSEL : 4 MHz interni oscilator
'
'********************************** KONEC *************************************
' Copyright (C) PaJa 2010
' www.paja-trb.cz